"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _styles = require("@material-ui/styles");

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _getWindowSizes2 = _interopRequireDefault(require("../utils/getWindowSizes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Be careful using this hook. It only works because the number of
 * breakpoints in theme is static. It will break once you change the number of
 * breakpoints. See https://reactjs.org/docs/hooks-rules.html#only-call-hooks-at-the-top-level
 */
var getNextScreen = function getNextScreen(keys, screen) {
  var index = keys.indexOf(screen);
  if (index === keys.length - 1) return null;
  return keys[index + 1];
};

var getScreenBefore = function getScreenBefore(keys, screen) {
  var index = keys.indexOf(screen);
  if (index === 0) return null;
  return keys[index - 1];
};

var getScreen = function getScreen(breakpoints) {
  var _getWindowSizes = (0, _getWindowSizes2["default"])(),
      width = _getWindowSizes.width;

  var screen = 'xs';
  breakpoints.keys.some(function (key) {
    if (width < breakpoints.values[key]) {
      screen = key;
      return true;
    }

    return false;
  });
  return screen;
};

function useWidth() {
  var theme = (0, _styles.useTheme)();
  var breakpoints = theme.breakpoints;

  var _useState = (0, _react.useState)(getScreen(breakpoints)),
      _useState2 = _slicedToArray(_useState, 2),
      screen = _useState2[0],
      setScreen = _useState2[1];

  var keys = _toConsumableArray(breakpoints.keys).reverse();

  var result = keys.reduce(function (output, key) {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    var matches = (0, _useMediaQuery["default"])(theme.breakpoints.only(key));
    return !output && matches ? key : output;
  }, null) || 'xs';
  (0, _react.useEffect)(function () {
    if (getNextScreen(keys, screen) === result || getScreenBefore(keys, screen) === result) {
      setScreen(result);
    }
  }, [result]);
  return screen;
}

var _default = useWidth; // import { useEffect, useRef, useState } from 'react';
// import { useTheme } from '@material-ui/core/styles';
// import getWindowSizes from 'utils/getWindowSizes';
//
// const useWidth = (interval = 200) => {
//   const { breakpoints } = useTheme();
//   const [screen, setScreen] = useState(getScreen(breakpoints));
//
//   const debounced = useRef(() =>
//     setTimeout(() => {
//       const calculatedScreen = getScreen(breakpoints);
//       if (screen !== calculatedScreen) {
//         setScreen(calculatedScreen);
//       }
//     }, interval),
//   );
//   useEffect(() => {
//     window.addEventListener('resize', debounced.current);
//     return () => {
//       window.removeEventListener('resize', debounced.current);
//     };
//   }, []);
//   console.log('screen', screen);
//   return screen;
// };
//
// export default useWidth;

exports["default"] = _default;